All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 To see the built-in library of shell functions contained in mr:
113 mr config DEFAULT lib
115 The ~/.mrconfig file is used by default. To use a different config file,
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
157 Just operate on the repository for the current directory, do not
158 recurse into deeper repositories.
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
174 Here is an example .mrconfig file:
177 checkout = svn co svn://svn.example.com/src/trunk src
181 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
183 git checkout -b mybranch origin/master
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
189 The "DEFAULT" section allows setting default values for the sections that
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. (For the "register" action, "MR_REPO" is instead set to the
213 basename of the directory that should be created when checking the
216 The "MR_CONFIG" environment variable is set to the .mrconfig file
217 that defines the repo being acted on, or, if the repo is not yet in a config
218 file, the .mrconfig file that should be modified to register the repo.
220 A few parameters have special meanings:
226 If the "skip" parameter is set and its command returns true, then B<mr>
227 will skip acting on that repository. The command is passed the action
230 Here are two examples. The first skips the repo unless
231 mr is run by joey. The second uses the hours_since function
232 (included in mr's built-in library) to skip updating the repo unless it's
233 been at least 12 hours since the last update.
235 skip = test $(whoami) != joey
236 skip = [ "$1" = update ] && ! hours_since "$1" 12
240 The "order" parameter can be used to override the default ordering of
241 repositories. The default order value is 10. Use smaller values to make
242 repositories be processed earlier, and larger values to make repositories
245 Note that if a repository is located in a subdirectory of another
246 repository, ordering it to be processed earlier is not recommended.
250 If the "chain" parameter is set and its command returns true, then B<mr>
251 will try to load a .mrconfig file from the root of the repository. (You
252 should avoid chaining from repositories with untrusted committers.)
256 If the "include" parameter is set, its command is ran, and should output
257 additional mrconfig file content. The content is included as if it were
258 part of the including file.
260 Unlike all other parameters, this parameter does not need to be placed
265 The "lib" parameter can specify some shell code that will be run before each
266 command, this can be a useful way to define shell functions for other commands
271 When looking for a command to run for a given action, mr first looks for
272 a parameter with the same name as the action. If that is not found, it
273 looks for a parameter named "rcs_action" (substituting in the name of the
274 revision control system and the action). The name of the revision control
275 system is itself determined by running each defined "rcs_test" action,
278 Internally, mr has settings for "git_update", "svn_update", etc. To change
279 the action that is performed for a given revision control system, you can
280 override these rcs specific actions. To add a new revision control system,
281 you can just add rcs specific actions for it.
285 Copyright 2007 Joey Hess <joey@kitenet.net>
287 Licensed under the GNU GPL version 2 or higher.
289 http://kitenet.net/~joey/code/mr/
298 use Cwd qw(getcwd abs_path);
308 print STDERR "mr: interrupted\n";
312 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
313 my $config_overridden=0;
322 my $directory=getcwd();
324 Getopt::Long::Configure("no_permute");
325 my $result=GetOptions(
326 "d|directory=s" => sub { $directory=abs_path($_[1]) },
327 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
328 "v|verbose" => \$verbose,
329 "s|stats" => \$stats,
330 "n|no-recurse" => \$no_recurse,
331 "j|jobs=i" => \$jobs,
333 if (! $result || @ARGV < 1) {
334 die("Usage: mr [-d directory] action [params ...]\n".
335 "(Use mr help for man page.)\n");
338 if (! defined $directory) {
339 die("mr: failed to determine working directory\n");
342 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
343 # the config file might be a symlink to elsewhere, and the directory it's
345 if ($ENV{MR_CONFIG} !~ /^\//) {
346 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
348 # Try to set MR_PATH to the path to the program.
350 use FindBin qw($Bin $Script);
351 $ENV{MR_PATH}=$Bin."/".$Script;
355 loadconfig($ENV{MR_CONFIG});
357 #print Dumper(\%config);
359 # alias expansion and command stemming
360 my $action=shift @ARGV;
361 if (exists $alias{$action}) {
362 $action=$alias{$action};
364 if (! exists $knownactions{$action}) {
365 my @matches = grep { /^\Q$action\E/ }
366 keys %knownactions, keys %alias;
370 elsif (@matches == 0) {
371 die "mr: unknown action \"$action\" (known actions: ".
372 join(", ", sort keys %knownactions).")\n";
375 die "mr: ambiguous action \"$action\" (matches: ".
376 join(", ", @matches).")\n";
380 # commands that do not operate on all repos
381 if ($action eq 'help') {
382 exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
384 elsif ($action eq 'config') {
386 die "mr config: not enough parameters\n";
389 if ($section=~/^\//) {
390 # try to convert to a path relative to the config file
391 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
393 $dir.="/" unless $dir=~/\/$/;
394 if ($section=~/^\Q$dir\E(.*)/) {
400 if (/^([^=]+)=(.*)$/) {
401 $changefields{$1}=$2;
405 foreach my $topdir (sort keys %config) {
406 if (exists $config{$topdir}{$section} &&
407 exists $config{$topdir}{$section}{$_}) {
408 print $config{$topdir}{$section}{$_}."\n";
410 last if $section eq 'DEFAULT';
414 die "mr $action: $section $_ not set\n";
418 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
421 elsif ($action eq 'register') {
422 if (! $config_overridden) {
423 # Find the closest known mrconfig file to the current
425 $directory.="/" unless $directory=~/\/$/;
426 foreach my $topdir (reverse sort keys %config) {
427 next unless length $topdir;
428 if ($directory=~/^\Q$topdir\E/) {
429 $ENV{MR_CONFIG}=$configfiles{$topdir};
435 my $subdir=shift @ARGV;
436 if (! chdir($subdir)) {
437 print STDERR "mr $action: failed to chdir to $subdir: $!\n";
441 $ENV{MR_REPO}=getcwd();
442 my $command=findcommand("register", '', '', 'DEFAULT');
443 if (! defined $command) {
444 die "mr $action: unknown repository type\n";
447 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
448 $command="set -e; ".$config{''}{DEFAULT}{lib}."\n".
449 "my_action(){ $command\n }; my_action ".
450 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
451 print "mr $action: running >>$command<<\n" if $verbose;
452 exec($command) || die "exec: $!";
455 # an ordered list of repos
457 foreach my $topdir (sort keys %config) {
458 foreach my $subdir (sort keys %{$config{$topdir}}) {
462 order => $config{$topdir}{$subdir}{order},
467 $a->{order} <=> $b->{order}
469 $a->{topdir} cmp $b->{topdir}
471 $a->{subdir} cmp $b->{subdir}
474 # work out what repos to act on
477 foreach my $repo (@list) {
478 my $topdir=$repo->{topdir};
479 my $subdir=$repo->{subdir};
481 next if $subdir eq 'DEFAULT';
482 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
484 $dir.="/" unless $dir=~/\/$/;
485 $d.="/" unless $d=~/\/$/;
486 next if $no_recurse && $d ne $dir;
487 next if $dir ne $d && $dir !~ /^\Q$d\E/;
488 push @repos, [$dir, $topdir, $subdir];
491 # fallback to find a leaf repo
492 foreach my $repo (reverse @list) {
493 my $topdir=$repo->{topdir};
494 my $subdir=$repo->{subdir};
496 next if $subdir eq 'DEFAULT';
497 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
499 $dir.="/" unless $dir=~/\/$/;
500 $d.="/" unless $d=~/\/$/;
501 if ($d=~/^\Q$dir\E/) {
502 push @repos, [$dir, $topdir, $subdir];
509 # run the action on each repository and print stats
510 my (@ok, @failed, @skipped);
515 foreach my $repo (@repos) {
516 record($repo, action($action, @$repo));
519 if (! @ok && ! @failed && ! @skipped) {
520 die "mr $action: no repositories found to work on\n";
522 print "mr $action: finished (".join("; ",
523 showstat($#ok+1, "ok", "ok"),
524 showstat($#failed+1, "failed", "failed"),
525 showstat($#skipped+1, "skipped", "skipped"),
529 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
532 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
538 elsif (! @ok && @skipped) {
544 my ($action, $dir, $topdir, $subdir) = @_;
547 foreach my $rcs_test (
549 length $a <=> length $b
552 } grep { /_test/ } keys %{$config{$topdir}{$subdir}}) {
553 my ($rcs)=$rcs_test=~/(.*)_test/;
554 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
555 $test.="if my_$rcs_test; then echo $rcs; fi\n";
557 $test=$config{$topdir}{$subdir}{lib}."\n".$test
558 if exists $config{$topdir}{$subdir}{lib};
560 print "mr $action: running rcs test >>$test<<\n" if $verbose;
571 sub findcommand { #{{{
572 my ($action, $dir, $topdir, $subdir) = @_;
574 my $rcs=rcs_test(@_);
577 exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
578 return $config{$topdir}{$subdir}{$rcs."_".$action};
580 elsif (exists $config{$topdir}{$subdir}{$action}) {
581 return $config{$topdir}{$subdir}{$action};
589 my ($action, $dir, $topdir, $subdir) = @_;
591 $ENV{MR_CONFIG}=$configfiles{$topdir};
592 my $lib=exists $config{$topdir}{$subdir}{lib} ?
593 $config{$topdir}{$subdir}{lib}."\n" : "";
595 if ($action eq 'checkout') {
597 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
601 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
604 print "mr $action: creating parent directory $dir\n" if $verbose;
605 system("mkdir", "-p", $dir);
608 elsif ($action =~ /update/) {
610 return action("checkout", $dir, $topdir, $subdir);
616 my $skiptest=findcommand("skip", $dir, $topdir, $subdir);
617 my $command=findcommand($action, $dir, $topdir, $subdir);
619 if (defined $skiptest) {
620 my $test="set -e;".$lib.
621 "my_action(){ $skiptest\n }; my_action '$action'";
622 print "mr $action: running skip test >>$test<<\n" if $verbose;
623 my $ret=system($test);
625 if (($? & 127) == 2) {
626 print STDERR "mr $action: interrupted\n";
630 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
634 if ($ret >> 8 == 0) {
635 print "mr $action: $dir skipped per config file\n" if $verbose;
640 if (! $nochdir && ! chdir($dir)) {
641 print STDERR "mr $action: failed to chdir to $dir: $!\n";
644 elsif (! defined $command) {
645 my $rcs=rcs_test(@_);
646 if (! defined $rcs) {
647 print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
651 print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
657 print "mr $action: $topdir$subdir\n";
661 $s=~s/^\Q$topdir$subdir\E\/?//;
662 print "mr $action: $topdir$subdir (in subdir $s)\n";
664 $command="set -e; ".$lib.
665 "my_action(){ $command\n }; my_action ".
666 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
667 print "mr $action: running >>$command<<\n" if $verbose;
668 my $ret=system($command);
670 if (($? & 127) == 2) {
671 print STDERR "mr $action: interrupted\n";
675 print STDERR "mr $action: received signal ".($? & 127)."\n";
678 print STDERR "mr $action: failed ($ret)\n" if $verbose;
679 if ($ret >> 8 != 0) {
680 print STDERR "mr $action: command failed\n";
683 print STDERR "mr $action: command died ($ret)\n";
688 if ($action eq 'checkout' && ! -d $dir) {
689 print STDERR "mr $action: $dir missing after checkout\n";;
698 # run actions on multiple repos, in parallel
705 while (@fhs or @repos) {
706 while ($running < $jobs && @repos) {
708 my $repo = shift @repos;
709 pipe(my $outfh, CHILD_STDOUT);
710 pipe(my $errfh, CHILD_STDERR);
712 unless ($pid = fork) {
713 die "mr $action: cannot fork: $!" unless defined $pid;
714 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
715 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
720 exit action($action, @$repo);
724 push @active, [$pid, $repo];
725 push @fhs, [$outfh, $errfh];
728 my ($rin, $rout) = ('','');
730 foreach my $fh (@fhs) {
731 next unless defined $fh;
732 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
733 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
735 $nfound = select($rout=$rin, undef, undef, 1);
736 foreach my $channel (0, 1) {
737 foreach my $i (0..$#fhs) {
738 next unless defined $fhs[$i];
739 my $fh = $fhs[$i][$channel];
740 next unless defined $fh;
741 if (vec($rout, fileno($fh), 1) == 1) {
743 if (sysread($fh, $r, 1024) == 0) {
745 $fhs[$i][$channel] = undef;
746 if (! defined $fhs[$i][0] &&
747 ! defined $fhs[$i][1]) {
748 waitpid($active[$i][0], 0);
749 print STDOUT $out[$i][0];
750 print STDERR $out[$i][1];
751 record($active[$i][1], $? >> 8);
753 splice(@active, $i, 1);
758 $out[$i][$channel] .= $r;
766 my $dir=shift()->[0];
773 elsif ($ret == FAILED) {
777 elsif ($ret == SKIPPED) {
780 elsif ($ret == ABORT) {
784 die "unknown exit status $ret";
793 return "$count ".($count > 1 ? $plural : $singular);
799 sub loadconfig { #{{{
806 if (ref $f eq 'GLOB') {
815 my $absf=abs_path($f);
816 if ($loaded{$absf}) {
821 ($dir)=$f=~/^(.*\/)[^\/]+$/;
822 if (! defined $dir) {
825 $dir=abs_path($dir)."/";
827 if (! exists $configfiles{$dir}) {
828 $configfiles{$dir}=$f;
831 # copy in defaults from first parent
833 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
834 if ($parent eq '/') {
837 if (exists $config{$parent} &&
838 exists $config{$parent}{DEFAULT}) {
839 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
844 print "mr: loading config $f\n" if $verbose;
845 open($in, "<", $f) || die "mr: open $f: $!\n";
856 next if /^\s*\#/ || /^\s*$/;
857 if (/^\[([^\]]*)\]\s*$/) {
860 elsif (/^(\w+)\s*=\s*(.*)/) {
865 while (@lines && $lines[0]=~/^\s(.+)/) {
872 if ($parameter eq "include") {
873 print "mr: including output of \"$value\"\n" if $verbose;
874 unshift @lines, `$value`;
878 if (! defined $section) {
879 die "$f line $.: parameter ($parameter) not in section\n";
881 if ($section ne 'ALIAS' &&
882 ! exists $config{$dir}{$section} &&
883 exists $config{$dir}{DEFAULT}) {
885 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
887 if ($section eq 'ALIAS') {
888 $alias{$parameter}=$value;
890 elsif ($parameter eq 'lib') {
891 $config{$dir}{$section}{lib}.=$value."\n";
894 $config{$dir}{$section}{$parameter}=$value;
895 if ($parameter =~ /.*_(.*)/) {
899 $knownactions{$parameter}=1;
901 if ($parameter eq 'chain' &&
902 length $dir && $section ne "DEFAULT" &&
903 -e $dir.$section."/.mrconfig") {
904 my $ret=system($value);
906 if (($? & 127) == 2) {
907 print STDERR "mr $action: chain test interrupted\n";
911 print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
915 push @toload, $dir.$section."/.mrconfig";
921 die "$f line $line: parse error\n";
930 sub modifyconfig { #{{{
932 # the section to modify or add
933 my $targetsection=shift;
934 # fields to change in the section
935 # To remove a field, set its value to "".
942 open(my $in, "<", $f) || die "mr: open $f: $!\n";
947 my $formatfield=sub {
949 my @value=split(/\n/, shift);
951 return "$field = ".shift(@value)."\n".
952 join("", map { "\t$_\n" } @value);
956 while ($out[$#out] =~ /^\s*$/) {
957 unshift @blanks, pop @out;
959 foreach my $field (sort keys %changefields) {
960 if (length $changefields{$field}) {
961 push @out, "$field = $changefields{$field}\n";
962 delete $changefields{$field};
972 if (/^\s*\#/ || /^\s*$/) {
975 elsif (/^\[([^\]]*)\]\s*$/) {
976 if (defined $section &&
977 $section eq $targetsection) {
985 elsif (/^(\w+)\s*=\s(.*)/) {
990 while (@lines && $lines[0]=~/^\s(.+)/) {
996 if ($section eq $targetsection) {
997 if (exists $changefields{$parameter}) {
998 if (length $changefields{$parameter}) {
999 $value=$changefields{$parameter};
1001 delete $changefields{$parameter};
1005 push @out, $formatfield->($parameter, $value);
1009 if (defined $section &&
1010 $section eq $targetsection) {
1013 elsif (%changefields) {
1014 push @out, "\n[$targetsection]\n";
1015 foreach my $field (sort keys %changefields) {
1016 if (length $changefields{$field}) {
1017 push @out, $formatfield->($field, $changefields{$field});
1022 open(my $out, ">", $f) || die "mr: write $f: $!\n";
1027 # Finally, some useful actions that mr knows about by default.
1028 # These can be overridden in ~/.mrconfig.
1044 echo "mr (warning): $@" >&2
1050 if [ -z "$1" ] || [ -z "$2" ]; then
1051 error "mr: usage: hours_since action num"
1053 for dir in .git .svn .bzr CVS .hg _darcs; do
1054 if [ -e "$MR_REPO/$dir" ]; then
1055 flagfile="$MR_REPO/$dir/.mr_last$1"
1059 if [ -z "$flagfile" ]; then
1060 error "cannot determine flag filename"
1062 delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
1063 if [ "$delta" -lt "$2" ]; then
1071 svn_test = test -d "$MR_REPO"/.svn
1072 git_test = test -d "$MR_REPO"/.git
1073 bzr_test = test -d "$MR_REPO"/.bzr
1074 cvs_test = test -d "$MR_REPO"/CVS
1075 hg_test = test -d "$MR_REPO"/.hg
1076 darcs_test = test -d "$MR_REPO"/_darcs
1078 test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1079 test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1080 test "$(GIT_CONFIG="$MR_REPO"/config git-config --get core.bare)" = true
1082 svn_update = svn update "$@"
1083 git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
1084 bzr_update = bzr merge "$@"
1085 cvs_update = cvs update "$@"
1086 hg_update = hg pull "$@" && hg update "$@"
1087 darcs_update = darcs pull -a "$@"
1089 svn_status = svn status "$@"
1090 git_status = git status "$@" || true
1091 bzr_status = bzr status "$@"
1092 cvs_status = cvs status "$@"
1093 hg_status = hg status "$@"
1094 darcs_status = darcs whatsnew -ls "$@"
1096 svn_commit = svn commit "$@"
1097 git_commit = git commit -a "$@" && git push --all
1098 bzr_commit = bzr commit "$@" && bzr push
1099 cvs_commit = cvs commit "$@"
1100 hg_commit = hg commit -m "$@" && hg push
1101 darcs_commit = darcs commit -a -m "$@" && darcs push -a
1103 svn_diff = svn diff "$@"
1104 git_diff = git diff "$@"
1105 bzr_diff = bzr diff "$@"
1106 cvs_diff = cvs diff "$@"
1107 hg_diff = hg diff "$@"
1108 darcs_diff = darcs diff "$@"
1110 svn_log = svn log "$@"
1111 git_log = git log "$@"
1112 bzr_log = bzr log "$@"
1113 cvs_log = cvs log "$@"
1114 hg_log = hg log "$@"
1115 darcs_log = darcs changes "$@"
1116 git_bare_log = git log "$@"
1119 url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
1120 if [ -z "$url" ]; then
1121 error "cannot determine svn url"
1123 echo "Registering svn url: $url in $MR_CONFIG"
1124 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co $url $MR_REPO"
1126 url="$(LANG=C git-config --get remote.origin.url)" || true
1127 if [ -z "$url" ]; then
1128 error "cannot determine git url"
1130 echo "Registering git url: $url in $MR_CONFIG"
1131 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone $url $MR_REPO"
1133 url=$(cat .bzr/branch/parent)
1134 if [ -z "$url" ]; then
1135 error "cannot determine bzr url"
1137 echo "Registering bzr url: $url in $MR_CONFIG"
1138 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone $url $MR_REPO"
1140 repo=$(cat CVS/Repository)
1141 root=$(cat CVS/Root)
1142 if [ -z "$root" ]; then
1143 error "cannot determine cvs root"
1145 echo "Registering cvs repository $repo at root $root"
1146 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d $MR_REPO $repo"
1148 url=$(hg showconfig paths.default)
1149 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1150 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone $url $MR_REPO"
1152 url=$(cat _darcs/prefs/defaultrepo)
1153 echo "Registering darcs repository $url in $MR_CONFIG"
1154 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get $url $MR_REPO"
1156 url="$(LANG=C GIT_CONFIG=config git-config --get remote.origin.url)" || true
1157 if [ -z "$url" ]; then
1158 error "cannot determine git url"
1160 echo "Registering git url: $url in $MR_CONFIG"
1161 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare $url $MR_REPO"
1164 if [ ! -e "$MR_PATH" ]; then
1165 error "cannot find program path"
1167 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1171 ed = echo "A horse is a horse, of course, of course.."
1172 T = echo "I pity the fool."
1173 right = echo "Not found."
1176 # vim:sw=8:sts=0:ts=8:noet